Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members | Related Pages

# RobotPose Class Reference

A Pose2D with validity. More...

`#include <RobotPose.h>`

Inheritance diagram for RobotPose:

[legend]
Collaboration diagram for RobotPose:

[legend]
List of all members.

## Public Member Functions
| RobotPose ()
| Constructor.
const RobotPose & | operator= (const RobotPose &other)
| RobotPose (const Pose2D &otherPose)
| Cast Contructor.
const RobotPose & | operator= (const Pose2D &other)
| Assignment operator.
void | setPose (const Pose2D &p)
| The function sets the current pose.
void | setValidity (const double v)
| The function sets the validity of the current pose.
void | setPositionVariance (const double v)
| The function sets the validity of the current pose.
void | setFrameNumber (unsigned long frameNumber)
| The function sets the frame number of the current pose.
void | setTimestamp (unsigned long timestamp)
| The function sets the timestamp of the current pose.
const Pose2D | getPose () const
| The function returns the current pose.
const double & | getValidity () const
| The function returns the validity of the current pose.
const double & | getPositionVariance () const
| The function returns the variance of the current particle distribuiton of the robot pose.
double | getPositionStandardDeviation () const
| The function returns the standard deviation of the current particle distribuiton of the robot pose.
void | calculateMovement (const Pose2D &movementPerSec, double time, RobotPose &result) const
| The frame number when perceived.
## Public Attributes
double | validity
| The validity of the robot pose.
double | positionVariance
| The variance of the particle distribution from which the pose was generated.
Pose2D | greatestUncertainty
| direction of greatest uncertainty from the (x,y) average of all particles
bool | directionOfGreatestUncertaintyExists
| if particle distribution is symmetrical, this is false, otherwise its set to true
unsigned long | frameNumber
| The time when the position is calculated.
unsigned long | timestamp
| Speed measured by perceived distance to goal.
double | speedbyDistanceToGoal
| The distance to the field border.
double | distanceToBorder
| The angle to the field border.
double | angleToBorder
## Friends
In & | operator>> (In &stream, RobotPose &robotPose)
| Streaming operator that reads a robot pose from a stream.
Out & | operator<< (Out &stream, const RobotPose &robotPose)
| Streaming operator that writes a robot pose to a stream.

## Detailed Description

A Pose2D with validity.

Definition at line 19 of file RobotPose.h.

## Constructor & Destructor Documentation

RobotPose::RobotPose | ( |  | ) | `[inline]`

| Constructor. Definition at line 31 of file RobotPose.h. References directionOfGreatestUncertaintyExists.

RobotPose::RobotPose | ( | const Pose2D & | otherPose | ) | `[inline]`

| Cast Contructor. Definition at line 48 of file RobotPose.h. References directionOfGreatestUncertaintyExists, greatestUncertainty, Pose2D::Pose2D(), and positionVariance.

Here is the call graph for this function:

## Member Function Documentation

const RobotPose& RobotPose::operator= | ( | const RobotPose & | other | ) | `[inline]`

| Definition at line 33 of file RobotPose.h. References directionOfGreatestUncertaintyExists, frameNumber, greatestUncertainty, positionVariance, timestamp, and validity.

const RobotPose& RobotPose::operator= | ( | const Pose2D & | other | ) | `[inline]`

  | Assignment operator. Parameters:
  other | The other Pose2D that is assigned to this one
Returns: A reference to this object after the assignment. Reimplemented from Pose2D. Definition at line 56 of file RobotPose.h.

void RobotPose::setPose | ( | const Pose2D & | p | ) | `[inline]`

  | The function sets the current pose. Parameters:
  p | The pose.
Definition at line 67 of file RobotPose.h. Referenced by SlamSelfLocator::calcPoseFromSubCube(), GT2005StableSelfLocator::calcPoseFromSubCube(), GT2005SelfLocator::calcPoseFromSubCube(), SlamSelfLocator::execute(), GT2005StableSelfLocator::execute(), GT2005SelfLocator::execute(), and GT2004SelfLocator::execute().

void RobotPose::setValidity | ( | const double | v | ) | `[inline]`

  | The function sets the validity of the current pose. Parameters:
  v | The validity.
Definition at line 75 of file RobotPose.h. Referenced by SlamSelfLocator::calcPose(), GT2005StableSelfLocator::calcPose(), GT2005SelfLocator::calcPose(), SlamSelfLocator::calcPoseFromSubCube(), GT2005StableSelfLocator::calcPoseFromSubCube(), GT2005SelfLocator::calcPoseFromSubCube(), SlamSelfLocator::execute(), GTCamSelfLocator::execute(), GT2005StableSelfLocator::execute(), GT2005SelfLocator::execute(), GT2004SelfLocator::execute(), GTCamWorldState::getRobotPose(), GTCamSelfLocator::GTCamSelfLocator(), and operator>>().

void RobotPose::setPositionVariance | ( | const double | v | ) | `[inline]`

  | The function sets the validity of the current pose. Parameters:
  v | The validity.
Definition at line 81 of file RobotPose.h. References positionVariance. Referenced by GT2005SelfLocator::calcDistributionValidityByStandardDeviation().

void RobotPose::setFrameNumber | ( | unsigned long | frameNumber | ) | `[inline]`

| The function sets the frame number of the current pose. Definition at line 86 of file RobotPose.h. Referenced by SlamSelfLocator::execute(), GT2005StableSelfLocator::execute(), GT2005SelfLocator::execute(), GT2004SelfLocator::execute(), and LogPlayer::saveSynchronized().

void RobotPose::setTimestamp | ( | unsigned long | timestamp | ) | `[inline]`

| The function sets the timestamp of the current pose. Definition at line 91 of file RobotPose.h. Referenced by SlamSelfLocator::execute(), GT2005StableSelfLocator::execute(), GT2005SelfLocator::execute(), GT2004SelfLocator::execute(), and LogPlayer::saveSynchronized().

const Pose2D RobotPose::getPose | ( |  | ) | const`[inline]`

| The function returns the current pose. Returns: The pose. Attention: this function is obsolete and should not be used any more instead this object IS a pose instead of owning one Definition at line 100 of file RobotPose.h. Referenced by GT2005ObstaclesLocator::addPSDPercept(), SlamSelfLocator::calcPose(), GT2005StableSelfLocator::calcPose(), GT2005SelfLocator::calcPose(), AngleSymbols::drawAngles(), AngleSymbols::drawAngleShownByLeds(), GT2005BehaviorControl::drawOptions(), SlamSelfLocator::execute(), KickLogger::execute(), GT2005BasicBehaviorGoToPointAndAvoidObstacles::execute(), GT2005BasicBehaviorTurnAroundPointWithRadius::execute(), GT2005BasicBehaviorTurnAroundPointFast::execute(), GT2005BasicBehaviorTurnAroundPoint::execute(), GT2005BasicBehaviorGoToBallWithoutTurning::execute(), GT2005BasicBehaviorGoToBallPropagated::execute(), GT2005BasicBehaviorGoToBall::execute(), GT2005BasicBehaviorNewGoToBall::execute(), Geometry::fieldCoord2Relative(), PassSymbols::getAngleToPassReceiver(), PassSymbols::getAngleToPassSender(), RobotPoseSymbols::getDistanceToBorder(), GT2005StrategySymbols::getGoalieMaxPositionSpeed(), BallSymbols::getHypotheticalAngle(), BallSymbols::getKnownAngle(), BallSymbols::getKnownOrNearAngle(), BallSymbols::getPropagatedAngle(), BallSymbols::getSeenAngle(), KickSelectionSymbols::intentionalKickPossible(), KickSelectionSymbols::retrieveKick(), GTStandardConverter::setData(), PlayerPose::setRobotPose(), ObstaclesSymbols::update(), and BallSymbols::update().

const double& RobotPose::getValidity | ( |  | ) | const`[inline]`

| The function returns the validity of the current pose. Returns: The validity. Definition at line 108 of file RobotPose.h. Referenced by GT2005SelfLocator::calcPose(), SlamSelfLocator::calcPoseFromSubCube(), GT2005StableSelfLocator::calcPoseFromSubCube(), GT2005SelfLocator::calcPoseFromSubCube(), GT2005TeamBallLocator::calcRepresentativeParticleContainer(), MotionRatingBehaviorControl::doLocalise(), MotionRatingBehaviorControl::execute(), operator<<(), GT2005BehaviorControl::postExecute(), CLogAnalyzerBase::readRemoteCamWorldState(), RobotPoseSymbols::registerSymbols(), LogPlayer::saveSynchronized(), GTStandardConverter::setData(), and PlayerPose::setRobotPose().

const double& RobotPose::getPositionVariance | ( |  | ) | const`[inline]`

| The function returns the variance of the current particle distribuiton of the robot pose. Returns: The variance. Definition at line 114 of file RobotPose.h. References positionVariance. Referenced by RobotPoseSymbols::registerSymbols(), and GT2005HeadControl::showVisualizationQuality().

double RobotPose::getPositionStandardDeviation | ( |  | ) | const

| The function returns the standard deviation of the current particle distribuiton of the robot pose. Returns: The standard-deviation. Definition at line 9 of file RobotPose.cpp. References positionVariance. Referenced by RobotPoseSymbols::calculateSpeedFactorFromRobotPositionStandardDeviation(), and RobotPoseSymbols::getPositionStandardDeviation().

void RobotPose::calculateMovement | ( | const Pose2D & | movementPerSec,
|  | double | time,
|  | RobotPose & | result
| ) | const

  | The frame number when perceived. Parameters:
  movementPerSec | The movement with x- and y-translation in mm/s and rotation in rad/s
  time | The time in sec how long the robot moves
  result | The target pose.
Definition at line 14 of file RobotPose.cpp. References Vector2< V >::abs(), Pose2D::rotation, Pose2D::translation, Vector2< V >::x, Vector2< double >::x, Vector2< V >::y, and Vector2< double >::y. Referenced by VLCImageProcessor::execute().

Here is the call graph for this function:

## Friends And Related Function Documentation

In& operator>> | ( | In & | stream,
|  | RobotPose & | robotPose
| ) | `[friend]`

  | Streaming operator that reads a robot pose from a stream. Parameters:
  stream | The stream from which is read.
  robotPose | The robot pose object.
Returns: The stream. Definition at line 38 of file RobotPose.cpp.

Out& operator<< | ( | Out & | stream,
|  | const RobotPose & | robotPose
| ) | `[friend]`

  | Streaming operator that writes a robot pose to a stream. Parameters:
  stream | The stream to write on.
  robotPose | The robot pose object.
Returns: The stream. Definition at line 57 of file RobotPose.cpp.

## Member Data Documentation

double RobotPose::validity

| The validity of the robot pose. Definition at line 22 of file RobotPose.h. Referenced by operator<<(), operator=(), and operator>>().

double RobotPose::positionVariance

| The variance of the particle distribution from which the pose was generated. Definition at line 23 of file RobotPose.h. Referenced by getPositionStandardDeviation(), getPositionVariance(), operator=(), RobotPose(), and setPositionVariance().

Pose2D RobotPose::greatestUncertainty

| direction of greatest uncertainty from the (x,y) average of all particles Definition at line 24 of file RobotPose.h. Referenced by GT2005SelfLocator::calcDistributionValidityByStandardDeviation(), operator=(), and RobotPose().

bool RobotPose::directionOfGreatestUncertaintyExists

| if particle distribution is symmetrical, this is false, otherwise its set to true Definition at line 25 of file RobotPose.h. Referenced by GT2005SelfLocator::calcDistributionValidityByStandardDeviation(), operator=(), and RobotPose().

unsigned long RobotPose::frameNumber

| The time when the position is calculated. Definition at line 135 of file RobotPose.h. Referenced by GTCamSelfLocator::execute(), operator=(), and LogPlayer::saveCSV().

unsigned long RobotPose::timestamp

| Speed measured by perceived distance to goal. Definition at line 138 of file RobotPose.h. Referenced by GTCamSelfLocator::execute(), CLogAnalyzerBase::interpolate(), operator=(), CLogAnalyzerBase::readRemoteCamWorldState(), CLogAnalyzerBase::readWorldState(), LogPlayer::saveCSV(), LogPlayer::saveSynchronized(), and PlayerPose::setRobotPose().

double RobotPose::speedbyDistanceToGoal

| The distance to the field border. Definition at line 141 of file RobotPose.h. Referenced by GTCamSelfLocator::GTCamSelfLocator().

double RobotPose::distanceToBorder

| The angle to the field border. Definition at line 144 of file RobotPose.h.

double RobotPose::angleToBorder

| Definition at line 145 of file RobotPose.h. Referenced by RobotPoseSymbols::getAngleToBorder().

The documentation for this class was generated from the following files:

- Representations/Cognition/RobotPose.h
- Representations/Cognition/RobotPose.cpp